.setcpu "65816"
.smart

; See MetaspriteTest2.asm
.importzp SpriteCount
.import SpriteBuf1
.import SpriteBuf2
.import SpriteBuf3

; Used by MetaspriteTest2.asm
.export start_process_oam

.segment "CODE"

;=====================================================================================

.proc start_process_oam
php
rep #$10
sep #$20

ldx SpriteCount
lda #$01
clear_oam_loop:
cpx #$0200
beq finished_clearing_oam_loop
sta SpriteBuf1,x
stz SpriteBuf1+1,x
stz SpriteBuf1+2,x
stz SpriteBuf1+3,x
sta SpriteBuf3+1,x		;; sprite 3, 9th x bit
inx
inx
inx
inx
bra clear_oam_loop
finished_clearing_oam_loop:

ldy #$0000
sty SpriteCount

build_hioam_loop:
lda SpriteBuf3+14,y		;; sprite 3, size bit
asl
ora SpriteBuf3+13,y		;; sprite 3, 9th x bit
asl
ora SpriteBuf3+10,y		;; sprite 2, size bit
asl
ora SpriteBuf3+9,y		;; sprite 2, 9th x bit
asl
ora SpriteBuf3+6,y		;; sprite 1, size bit
asl
ora SpriteBuf3+5,y		;; sprite 1, 9th x bit
asl
ora SpriteBuf3+2,y		;; sprite 0, size bit
asl
ora SpriteBuf3+1,y		;; sprite 0, 9th x bit
sta SpriteBuf1,x
rep #$20
tya
clc
adc #$0010
tay
sep #$20
inx
cpx #$0220
bne build_hioam_loop

plp
rts

.endproc